<?php

class ControllerPaymenticcard extends Controller
{
	protected function index()
	{
    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
		$this->load->model('checkout/order');
		$this->load->library('iccard_payment_helper');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		if($this->currency->getCode()!='RLS')
		{
			$this->currency->set("RLS");
			echo('<html><head><meta http-equiv="refresh" CONTENT="1; url=index.php?route=checkout/confirm"></head><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">تنظیم ارز ریال...<br /><br /><a href="index.php?route=checkout/cart"><b>بازگشت به فروشگاه</b></a></td><td>&nbsp;</td></tr></table></body></html>');
			die();
		}

		$i = new ICCard_Payment_Helper($this->config->get('iccard_terminal'));
		$r = $i->paymentRequest($p = array(
				'amount'   => @$this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE),
				'order_id' => $this->session->data['order_id'],
				'callback' => $this->url->https('payment/iccard/callback'),
			));
		if ($r)
		{
			$this->data['token'] = $i->token;
			$this->id = 'payment';
			$this->template = $this->config->get('config_template') . 'payment/iccard.tpl';
			$this->render();		
		}
		else
		{
			exit ('Error : ' . $i->error);
		}
	}

	public function callback()
	{
		$order_id = @$this->request->post['invoiceid'];
		$this->load->model('checkout/order');
		$this->load->library('iccard_payment_helper');
		$order_info = $this->model_checkout_order->getOrder($order_id);
		if ($order_info)
		{
			$i = new ICCard_Payment_Helper($this->config->get('iccard_terminal'));
			$r = $i->paymentVerify($_POST);
			if ($r)
			{
				$this->model_checkout_order->confirm($order_id, $this->config->get('iccard_order_status_id'),'رسید دیجیتالی درگاه پرداخت کارت اعتباری ایرانیان '.$_POST['ref']);
				$this->response->setOutput('<html><head><meta http-equiv="refresh" CONTENT="2; url=index.php?route=checkout/success"></head><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">لطفا چند صبر کنید ، یا <a href="index.php?route=checkout/success"><b>اینجا کلیک کنید</b></a></td><td>&nbsp;</td></tr></table></body></html>');
			}
			else
			{
				$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">خطا در تکمیل مراحل پرداخت : '.$i->error.'<br /><br /><a href="index.php?route=checkout/cart"><b>بازگشت به فروشگاه</b></a></td><td>&nbsp;</td></tr></table></body></html>');
			}
		}
	}
}

?>